<?php
namespace Teknisa\PLA\Modules\Requisicao\Services;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Pla01800RequisicaoGeralRemoteRepository {

    protected $crudService;
    protected $dataSourceManager;

    public function __construct($crudService, $dataSourceManager){
        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
    }

    public function fetchServicos($params){
        //este parâmetro é fixo
        $params[]=array("columnName"=>"IDTIPOSERV", "operator"=>"=", "value"=>"N");
        $filterCriteria = new FilterCriteria("pla01800_servico", $params);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, array( "NRORG", "CDFILIAL", "CDOPERADOR", "CDGRUPSERV", "IDTIPOSERV"));
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $rows = $dataSet->getRows();
        return array_map(function($item){
            return array("CDFILIAL" => $item['CDFILIAL'], "CDSERVFILI" => $item['CDSERVFILI']);
        }, $rows);
    }

    public function fetchFiliais($params){
        $filterCriteria = new FilterCriteria("filial_operador_grupfili", $params);
        $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria,array("NRORG", "CDOPERADOR", "CDGRUPFILI"));
        $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
        $rows = $dataSet->getRows();
        return array_column($rows, "CDFILIAL");
    }

    public function fetchGrupoServicos(){
        $filterCriteria = new FilterCriteria("grupserv", array());
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $rows = $dataSet->getRows();
        return array_column($rows, "CDGRUPSERV");
    }

    public function fetchTipoPrato(){
        $filterCriteria = new FilterCriteria("tipoprat", array());
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
        $rows = $dataSet->getRows();
        return array_column($rows, "CDTIPOPRAT");
    }
}